function addload() {
	if (opener.readPref("WizzRSSAutoName", false, 2)) {
		document.getElementById("autoName").setAttribute("checked", true);
		document.getElementById("channelname").disabled = true;
	} else {
		document.getElementById("autoName").setAttribute("checked", false);
		document.getElementById("channelname").disabled = false;
	}

}

//**************************************************************************
function doAdd() {
	var canAdd = false;
	if (document.getElementById("autoName").checked) {
		if (document.getElementById("channelurl").value.length == 0) {
			alert(opener.strbundle.getString("nourl"));
		} else {
			canAdd = true;
		}
	} else {
		if (document.getElementById("channelname").value.length == 0) {
			alert(opener.strbundle.getString("noname"));
		} else if (document.getElementById("channelurl").value.length == 0) {
			alert(opener.strbundle.getString("nourl"));
		} else {
			canAdd = true;
		}
	}
	if (canAdd) {
		opener.busyOn();
		opener.opener.addEventListener("feedchecked", checkfeedHandler, true);
		opener.checkFeed(document.getElementById("channelurl").value);
	}
	return false;
}

//**************************************************************************
function checkfeedHandler() {

	opener.opener.removeEventListener("feedchecked", checkfeedHandler, true);
	var closeFlag = false;
	if (opener.checkfeedresult != null) {


		var feedname = "";
		if (document.getElementById("autoName").checked) {
			feedname = opener.trim(opener.checkfeedresult[0]);
		} else {
			feedname = document.getElementById("channelname").value;
		}

		var nodeId;
		if (opener.cattree.currentIndex == -1) {
			nodeId = opener.getTreePlaceURI()[2].itemId;
		} else {
			nodeId = opener.cattree.controller._view.selectedNode.itemId;
		}

		var annotations = [];
		var anno = {
			name: "bookmarkProperties/feedstatus",
			type: Components.interfaces.nsIAnnotationService.TYPE_STRING,
			flags: 0,
			value: "Unread",
			expires: Components.interfaces.nsIAnnotationService.EXPIRE_NEVER
		};
		annotations.push(anno);
		var anno1 = {
			name: "bookmarkProperties/description",
			type: Components.interfaces.nsIAnnotationService.TYPE_STRING,
			flags: 0,
			value: opener.checkfeedresult[1],
			expires: Components.interfaces.nsIAnnotationService.EXPIRE_NEVER
		};
		annotations.push(anno1);
		var anno2 = {
			name: "bookmarkProperties/feedhome",
			type: Components.interfaces.nsIAnnotationService.TYPE_STRING,
			flags: 0,
			value: opener.checkfeedresult[2],
			expires: Components.interfaces.nsIAnnotationService.EXPIRE_NEVER
		};
		annotations.push(anno2);

		var uri = Components.classes['@mozilla.org/network/standard-url;1'].createInstance(Components.interfaces.nsIURI);
		uri.spec = document.getElementById("channelurl").value;

		var txn = opener.PlacesUIUtils.ptm.createItem(uri, nodeId, -1, feedname, "", annotations);
		opener.PlacesUIUtils.ptm.doTransaction(txn);

		closeFlag = true;
	} else {
		alert(opener.strbundle.getString("urlerr"));
	}

	opener.busyOff();

	if (closeFlag) {
		doCancel();
	}

}

//**************************************************************************
function doCancel() {
	document.getElementById("addChannel").cancelDialog();
}

//**************************************************************************
function toggleName() {
	if (document.getElementById("channelname").disabled == false) {
		document.getElementById("channelname").disabled = true;
		opener.writePref("WizzRSSAutoName", true, 2);
	} else {
		document.getElementById("channelname").disabled = false;
		opener.writePref("WizzRSSAutoName", false, 2);
	}
}