var persist;
var filesize = 0;
var pointer = 0;

function doCancel() {
	pointer = window.arguments[0].length - 1;
	persist.cancelSave();
}

function saveEncload() {
	if (pointer == window.arguments[0].length) {
		document.getElementById("saveEnc").acceptDialog();
	} else {

		var data = window.arguments[0][pointer].split("-;-");

		if (window.arguments[2] != "man") {
			data[1] = data[1].replace(/\W|\s/g, "");
		}

		document.getElementById("files").value = window.arguments[0].length;
		document.getElementById("busywith").value = pointer + 1;
		if (window.arguments[2] != "man") {		
			document.getElementById("URL").value = data[0];
		} else {
			document.getElementById("URL").value = window.arguments[0][pointer];
		}
		document.getElementById("size").value = "0";
		document.getElementById("done").value = "0";

		var uri = Components.classes['@mozilla.org/network/standard-url;1'].createInstance(Components.interfaces.nsIURI);
		uri.spec = data[0];
		var savepath;

		if (window.arguments[2] == "man") {
			savepath = window.arguments[1];
		} else {
			savepath = window.arguments[1] + data[1];
			if (savepath.search(/\\/) != -1) {
				savepath = savepath + "\\";
			} else {
				if (savepath.search(/:/) == -1) {
					savepath = savepath + "/";
				} else {
					savepath = savepath + "\\";
				}
			}
			var prepend = opener.readPref("WizzRSSWatchListPrepend", true, 2);
			var today = new Date();
			var fileName = data[0].substring(data[0].lastIndexOf("/") + 1);
			var pos = fileName.indexOf("?");
			if (pos > 0) {
				fileName = fileName.substring(0, pos);
			}

			if (fileName.length == 0) {
				fileName = "Unknown.html";
			}

			if (prepend) {
				savepath += today.getTime() + "_" + fileName;
			} else {
				savepath += fileName;
			}
			opener.fireWizzEvent("savedfile");
		}

		document.getElementById("savepath").value = savepath;
			
		var outputFile = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
		const nsIWBP = Components.interfaces.nsIWebBrowserPersist;
		try {
			outputFile.initWithPath(savepath);
			if(outputFile.exists()) {
				outputFile.remove(true);
			}
			outputFile.create(outputFile.NORMAL_FILE_TYPE, 0666);

			persist = Components.classes['@mozilla.org/embedding/browser/nsWebBrowserPersist;1'].createInstance(Components.interfaces.nsIWebBrowserPersist);
			var flags = nsIWBP.PERSIST_FLAGS_REPLACE_EXISTING_FILES | nsIWBP.PERSIST_FLAGS_BYPASS_CACHE;
			persist.persistFlags = flags;
			persist.progressListener = new PersistProgressListener();
			persist.saveURI(uri, null, null, null, null, outputFile);
		} catch (e) {
			filesize = 0;
			document.getElementById("size").value = filesize;
			pointer++;
			saveEncload();
		}
	}
}

function PersistProgressListener() {}

PersistProgressListener.prototype = {
	QueryInterface : function(aIID) {
	if(aIID.equals(Components.interfaces.nsIWebProgressListener))
	return this;
	throw Components.results.NS_OK;
},

init :function() {var flag=0; var identity=0;},
destroy :function() {},
 
onStateChange:(function (aWebProgress, aRequest, aStateFlags, aStatus) {
	if (aStateFlags & Components.interfaces.nsIWebProgressListener.STATE_STOP) {
		filesize = 0;
		document.getElementById("size").value = filesize;
		pointer++;
		saveEncload();
	}
}),

onProgressChange:(function (aWebProgress, aRequest, aCurSelfProgress, aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress) {
	if (filesize == 0) {
		filesize = aMaxTotalProgress;
		if (filesize != -1) {
			document.getElementById("size").value = filesize;
		} else {
			document.getElementById("meter").setAttribute("mode", "undetermined");
			document.getElementById("size").value = unknown;
		}
	}
	document.getElementById("done").value = aCurTotalProgress;
	if (filesize != -1) {
		var meterval = (aCurTotalProgress / filesize) * 100;
		document.getElementById("meter").value = meterval;
	}
}),

onLocationChange: (function (aWebProgress, aRequest, aLocation) {
}),

onStatusChange:(function (aWebProgress, aRequest, aStatus, aMessage) {
}),

onSecurityChange:(function (aWebProgress, aRequest, aState) {
})};