var outputStream;
var inputStream;
var transport;
var sendStatus = 0;
var connected = false;
var senderrflag = true;

var emailsubject;
var msg;
var hostname;
var portnum;
var sendername;
var senderemail;
var links;
var sendersig;
var receiveremail = "";
var receiverarray;
var sendcount;

//**************************************************************************
function smtpStuff(val, value, smtptree) {
	hostname = readPref("WizzRSSSMTPHost", "", 1);
	portnum = readPref("WizzRSSSMTPPort", 25, 3);
	sendername = readPref("WizzRSSSMTPName", "", 1);
	senderemail = readPref("WizzRSSSMTPEmail", "", 1);
	sendersig = readPref("WizzRSSSMTPSig", "", 1);
	if (hostname.length == 0 || sendername.length == 0 || senderemail.length == 0) {
		alert(strbundle.getString("smtpmsg"));
	} else {
		receiveremail = prompt(strbundle.getString("toemailtext"), readPref("WizzRSSLastEmail", "", 1), strbundle.getString("toemailtitle"));
		if (receiveremail != null && receiveremail.length != 0) {
			receiverarray = receiveremail.split(";");
			sendcount = 0;
			writePref("WizzRSSLastEmail", receiveremail, 1);
			if (val == 0) {

				var node = smtptree.controller._view.selectedNode;

				if (node.type == node.RESULT_TYPE_FOLDER) {

					var folder = node.QueryInterface(Components.interfaces.nsINavHistoryContainerResultNode);
					var currentState = folder.containerOpen;

					if (!currentState) {
						folder.containerOpen = true;
					}

					var urlArray = new Array();
					var catArray = new Array();
					for (var i = 0; i < folder.childCount; i ++) {
						var foldernode = folder.getChild(i);
						if (foldernode.type == foldernode.RESULT_TYPE_URI) {
							var url = trim(foldernode.uri);
							var feedname = foldernode.title;
							if (url.length > 0) {
								urlArray.push(url);
								catArray.push(foldernode.title);
							}
						}
					}

					folder.containerOpen = currentState;

					if (urlArray.length == 0) {
						alert(strbundle.getString("nochannels"));
						return;
					} else if (urlArray.length == 1) {
						if (!readPref("WizzRSSHeadlineAsSubject", false, 2)) {
							emailsubject = strbundle.getString("newsfeedsubject") + " " + sendername;
						} else {
							emailsubject = node.title;
						}
					} else {
						if (!readPref("WizzRSSHeadlineAsSubject", false, 2)) {
							emailsubject = strbundle.getString("newsfeedssubject") + " " + sendername;
						} else {
							emailsubject = node.title;
						}
					}
					links = "";
					for (var n = 0; n < urlArray.length; n++) {
						links += "<strong>" + HTMLEncode(catArray[n]) + "</strong><br>\r\n";
						links += "<font size=\"1\"><a href=\"" + urlArray[n] + "\">XML</a></font><br><br>\r\n";
					}
					links += "<br>";
				} else if (node.type == node.RESULT_TYPE_URI) {
					if (!readPref("WizzRSSHeadlineAsSubject", false, 2)) {
						emailsubject = strbundle.getString("newsfeedsubject") + " " + sendername;
					} else {
						emailsubject = node.title;
					}
					links = "<strong>" + HTMLEncode(node.title) + "</strong><br>\r\n";
					links += "<font size=\"1\"><a href=\"" + node.uri + "\">XML</a></font><br><br><br>\r\n";
				}
			} else {
				var values = value.split("-;-");
				links = "<strong>" + HTMLEncode(values[0]) + "</strong><br><br>\r\n";
				links += HTMLEncode(values[2]) + "<br>\r\n";
				links += "<font size=\"1\"><a href=\"" + values[1] + "\">Read more...</a></font><br><br><br>\r\n";
				if (values[3].length > 0) {
					links += "<font size=\"1\"><a href=\"" + values[3] + "\">Enclosure...</a></font><br><br><br>\r\n";
				}
				if (!readPref("WizzRSSHeadlineAsSubject", false, 2)) {
					emailsubject = strbundle.getString("newsitemsubject") + " " + sendername;
				} else {
					emailsubject = values[0];
				}
			}
			msg = "<!DOCTYPE html PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n";
			msg += "<html>\r\n";
			msg += "<head>\r\n";
			msg += "\t<meta content=\"text/html;charset=UTF-8\" http-equiv=\"Content-Type\">\r\n";
			msg += "\t<title></title>\r\n";
			msg += "</head>\r\n";
			msg += "<body bgcolor=\"#ffffff\" text=\"#000000\">\r\n";
			msg += "<font face=\"Verdana, Arial, Helvetica\" size=\"2\"><br><br>\r\n";
			msg += links + "\r\n";
			msg += sendersig + "\r\n";
			msg += "<hr>\r\n";
			msg += "<font size=\"1\">\r\n";
			msg += "Brought to you by <a href=\"http://www.wizzrss.com/WizzRss.php\">Wizz RSS News Reader</a>";
			msg += "</font></font>\r\n";
			msg += "</body>\r\n";
			msg += "</html>\r\n";
			sendStatus = 0;
			sendEMail();
		}
	}
}

//**************************************************************************
function sendEMail() {
	connected = false;
	try {
		var transportService = Components.classes["@mozilla.org/network/socket-transport-service;1"].getService(Components.interfaces.nsISocketTransportService);
		transport = transportService.createTransport(null, 0, hostname, portnum, null);
		outputStream = transport.openOutputStream(0, 0, 0);
		var Stream = transport.openInputStream(0, 0, 0);
		inputStream = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
		inputStream.init(Stream);
		var dataListener = {
			onStartRequest: function(request, context) {
				connected = true;
				senderrflag = true;
			},
			onStopRequest: function(request, context, status) {
				if (!connected) {
					alert(strbundle.getString("emailsenderr") + " " + hostname + ":" + portnum);
				} else {
					connected = false;
					outputStream.close();
					inputStream.close();
				}
			},
			onDataAvailable: function(request, context, inStream, offset, count) {
				readMsg(inputStream.read(count));
			}
		};
		var pump = Components.classes["@mozilla.org/network/input-stream-pump;1"].createInstance(Components.interfaces.nsIInputStreamPump);
		pump.init(Stream, -1, -1, 0, 0, false);
		pump.asyncRead(dataListener, null);
	} catch (e) {}
}

//**************************************************************************
function readMsg(ret) {
	var SMTPCmd = ret.substring(0, 3);
	if (SMTPCmd == "220") {
		var DNSService = Components.classes["@mozilla.org/network/dns-service;1"].getService(Components.interfaces.nsIDNSService);
		sendMessage("HELO " + DNSService.myHostName + "\r\n");
	} else if (SMTPCmd == "250") {
		if (sendStatus == 4) {
			sendMessage("QUIT\r\n");
			senderrflag = false;
		} else if (sendStatus == 2) {
			sendMessage("DATA\r\n");
			sendStatus = 3;
		} else if (sendStatus == 1) {
			sendMessage("RCPT To: <" + trim(receiverarray[sendcount]) + ">\r\n");
			sendcount++;
			if (sendcount == receiverarray.length) {
				sendStatus = 2;
			}
		} else if (sendStatus == 0) {
			sendMessage("MAIL From: <" + senderemail + ">\r\n");
			sendStatus = 1;
		}
	} else if (SMTPCmd == "354") {
		sendStatus = 4;
		var today = new Date();
		var Msg = "Date: " + today.toString() + "\r\n"
		Msg += "From: " + sendername + " <" + senderemail + ">\r\n";
		Msg += "User-Agent: Wizz RSS News Reader\r\n";
		Msg += "MIME-Version: 1.0\r\n";
		Msg += "To: " + receiveremail + "\r\n";
		Msg += "Subject: " + emailsubject + "\r\n";
		Msg += "Content-Type: text/html; charset=UTF-8\r\n";
		Msg += "Content-Transfer-Encoding: 8bit\r\n\r\n";

		msg = msg.replace(/\r\n/g, "\n");
		msg = msg.replace(/\n/g, "\r\n");

		Msg += msg;
		Msg += ".\r\n";
		sendMessage(Msg);
	} else if (SMTPCmd == "221") {
		if (!senderrflag) {
			alert(strbundle.getString("emailsentmsg") + " " + receiveremail);
		}
	} else {
		sendMessage("QUIT\r\n");
		alert(strbundle.getString("smtperror") + " - " + ret);
	}
}

//**************************************************************************
function sendMessage(Msg) {
	outputStream.write(Msg, Msg.length);
}

//**************************************************************************
function HTMLEncode(t) {
	var d = "";
	var val;
	for (var n = 0; n < t.length; n++) {
		val = t.charCodeAt(n);
		if (val > 127) {
			d += "&#" + val + ";";
		} else {
			d += t.substring(n, n + 1);
		}
	}
	return d;
}