var password;

//**************************************************************************
function accountload() {
	document.getElementById("accounttext").value = opener.strbundle.getString("accounttext");
	document.getElementById("username").value = unescape(opener.readPref("WizzRSSUserName", "", 1));
	document.getElementById("passwordtext").value = unescape(opener.readPref("WizzRSSPassword", "", 1));
	if (opener.readPref("WizzRSSSavePassword", true, 2)) {
		document.getElementById("passOption").setAttribute("checked", true);
	} else {
		document.getElementById("passwordtext").disabled = true;
	}
}

//**************************************************************************
function togglesave(val) {
	if (val) {
		document.getElementById("passwordtext").disabled = false;
	} else {
		document.getElementById("passwordtext").disabled = true;
	}
}

//**************************************************************************
function doAccountOK() {
	opener.writePref("WizzRSSUserName", escape(document.getElementById("username").value), 1);
	if (document.getElementById("passOption").getAttribute("checked")) {
		opener.writePref("WizzRSSPassword", escape(document.getElementById("passwordtext").value), 1);
	} else {
		opener.writePref("WizzRSSPassword", "", 1);
	}
	if (document.getElementById("passOption").getAttribute("checked")) {
		opener.writePref("WizzRSSSavePassword", true, 2);
	} else {
		opener.writePref("WizzRSSSavePassword", false, 2);
	}
	document.getElementById("account").acceptDialog();
}

//**************************************************************************
function setPassword(val) {
	password = escape(val);
}

//**************************************************************************
function createAcc() {
	var username = escape(document.getElementById("username").value);
	if (username.length == 0) {
		alert(opener.strbundle.getString("createerr"));
	} else {
		if (document.getElementById("passOption").getAttribute("checked")) {
			password = escape(document.getElementById("passwordtext").value);
		} else {
			password = null;
			var dialogURL = "chrome://wizzrss/content/password.xul";
			var options = "chrome, modal";
			window.openDialog(dialogURL, "", options, "0");
		}
		if (password != null) {
			if (username.length == 0 || password.length == 0) {
				alert(opener.strbundle.getString("createerr"));
			} else {
				opener.busyOn();
				var xmlReq = new XMLHttpRequest();
				xmlReq.open("GET", "http://www.wizzrss.com/wizzrss2/CreateAcc.php?uname=" + username + "&pword=" + password + "&loc=" + opener.wizzlocale, true);
				xmlReq.onload = createAccOnLoad;
				xmlReq.onerror = handleError;
				xmlReq.send(null);
			}
		}
	}
}

//**************************************************************************
function handleError(event) {
	opener.busyOff();
	alert(opener.strbundle.getString("serverresperr"));
}

//**************************************************************************
function createAccOnLoad(event) {
	var text = event.target.responseText;
	opener.busyOff();
	if (text.substring(0, 2) == "OK") {
		alert(text.substring(2));
	} else {
		alert(opener.strbundle.getString("serverresperr"));
	}
}

//**************************************************************************
function changePass() {
	var options = "chrome, modal";
	var dialogURL = "chrome://wizzrss/content/password.xul";
	var username = escape(document.getElementById("username").value);
	if (username.length == 0) {
		alert(opener.strbundle.getString("changeerr"));
	} else {
		if (document.getElementById("passOption").getAttribute("checked")) {
			password = escape(document.getElementById("passwordtext").value);
		} else {
			password = null;
			window.openDialog(dialogURL, "", options, "0");
		}
		if (password != null) {
			if (username.length == 0 || password.length == 0) {
				alert(opener.strbundle.getString("changeerr"));
			} else {
				var oldPassword = password;
				password = null;
				window.openDialog(dialogURL, "", options, "1");
				if (password != null && password.length > 0) {
					opener.busyOn();
					var xmlReq = new XMLHttpRequest();
					xmlReq.open("GET", "http://www.wizzrss.com/wizzrss2/ChangePass.php?uname=" + username + "&pword=" + oldPassword + "&npword=" + password + "&loc=" + opener.wizzlocale, true);
					xmlReq.onload = changePassOnLoad;
					xmlReq.onerror = handleError;
					xmlReq.send(null);
				}
			}
		}
	}
}

//**************************************************************************
function changePassOnLoad(event) {
	var text = event.target.responseText;
	opener.busyOff();
	if (text.substring(0, 2) == "OK") {
		if (document.getElementById("passOption").getAttribute("checked")) {
			document.getElementById("passwordtext").value = unescape(password);
		}
		alert(text.substring(2));
	} else if (text.substring(0, 2) == "KO") {
		alert(text.substring(2));
	} else {
		alert(opener.strbundle.getString("serverresperr"));
	}
}