var isBusy = false;
var strbundle;
var cattree;
var itemlist;
var itemdesc;

var wizzitemlist;
var wizzitemdesc;

var viewitemlist;
var viewitemdesc;

var screenx;
var screeny;
var currentIndex;
var retrycount;
var currentResource;
var iswindow;
var feedcheckdroppedurl;
var treeDropIP;

if (opener == null) {
	opener = parent;
	iswindow = false;
} else {
	iswindow = true;
}

//**************************************************************************
function wizzrssload(event) {

	strbundle = opener.strbundle;

	if (!readPref("WizzRSSSkipHistCheck", false, 2)) {
		if (readPref("browser.history_expire_days", 0, 3) == 0) {
			alert(strbundle.getString("histDisabled"));
		}

		if (readPref("privacy.sanitize.sanitizeOnShutdown", true, 2) && readPref("privacy.item.history", true, 2)) {
			alert(strbundle.getString("histCleared"));
		}
	}

	opener.addEventListener("updateind", eventHandler, true);
	opener.addEventListener("iconsoff", iconsOff, true);
	opener.addEventListener("iconson", iconsOn, true);
	opener.addEventListener("fontchange", fontChange, true);
	opener.addEventListener("changeid", changeid, true);
	opener.addEventListener("hidedesc", hidedesc, true);
	opener.addEventListener("showdesc", showdesc, true);
	opener.addEventListener("foundnew", foundnew, true);
	opener.addEventListener("savedfile", savedfile, true);

	if (iswindow) {
		opener.addEventListener("close", shutdown, true);
	}

	cattree = document.getElementById("cattree");

	cattree.setAttribute("style", "font-size: " + readPref("WizzRSSFontSize", 11, 3) + "px !important;");

	var placeuri = getTreePlaceURI()[0];
	if (placeuri == null) {
		
		var anno = [];
		var txn = PlacesUIUtils.ptm.createFolder("Wizz RSS", PlacesUIUtils.allBookmarksFolderId, -1, anno);
		PlacesUIUtils.ptm.doTransaction(txn);
		cattree.place = getTreePlaceURI()[0];

		if (confirm(strbundle.getString("importPublicList"))) {
			importLists();
		} else {
			var uri = IOService.newURI("http://wizzrss.blat.co.za/feed/", null, null);
			var newbm = BMSVC.insertBookmark(getTreePlaceURI()[1], uri, -1, "Wizz RSS Blog");
			annotations.setItemAnnotation(newbm, "bookmarkProperties/feedstatus", "Unread", 0, annotations.EXPIRE_NEVER);
		}

	} else {
		cattree.place = placeuri;
	}

	wizzitemlist = document.getElementById("itemlist");
	wizzitemlist.setAttribute("style", "font-size: " + readPref("WizzRSSFontSize", 11, 3) + "px !important;");

	viewitemlist = document.getElementById("viewitemlist");
	viewitemlist.setAttribute("style", "font-size: " + readPref("WizzRSSFontSize", 11, 3) + "px !important;");

	document.getElementById("saveditemlist").setAttribute("style", "font-size: " + readPref("WizzRSSFontSize", 11, 3) + "px !important;");

	wizzitemdesc = document.getElementById("itemdesc");
	viewitemdesc = document.getElementById("viewitemdesc");

	itemlist = wizzitemlist;
	itemdesc = wizzitemdesc;

	if (readPref("WizzRSSHideTreeIcons", false, 2)) {
		cattree.setAttribute("hideicons", "true");
	} else {
		cattree.setAttribute("hideicons", "false");
	}

	if (readPref("WizzRSSHideDesc", false, 2)) {
		hidedesc();
	}

	var reader = new itemReader(new Array(null));
	reader.addListItems(null);

	var currentWizzTab = readPref("WizzRSSCurrentTab", 0, 3);
	if (currentWizzTab == 1) {
		loadViewItems(false, null);
	} else if (currentWizzTab == 2) {
		loadSavedItems();
	}
	document.getElementById("wizztabs").selectedIndex = currentWizzTab;

	if (readPref("WizzRSSHideRMini", false, 2)) {
		hidemini(0);
	}

	if (readPref("WizzRSSHideFMini", false, 2)) {
		hidemini(1);
	}

	if (readPref("WizzRSSHideTabs", false, 2)) {
		hidetabs(1);
	}

}

//**************************************************************************
function abortFeedRead() {
	if (isBusy) {
		opener.fireWizzEvent("abortfeedread");
	}
}

//**************************************************************************
function hidemini(val) {
	var minitb;
	var hideit = true;
	if (val == 0) {
		minitb = document.getElementById("reader-mini");
	} else {
		minitb = document.getElementById("founditems-mini");
	}
	if (minitb.style.height == "" || minitb.style.height == "21px") {
		minitb.style.height = "5px";
		minitb.setAttribute("tooltiptext", strbundle.getString("minitooltip"));
	} else {
		hideit = false
		minitb.style.height = "21px";
		minitb.setAttribute("tooltiptext", "");
	}
	if (val == 0) {
		writePref("WizzRSSHideRMini", hideit, 2);
	} else {
		writePref("WizzRSSHideFMini", hideit, 2);
	}
}

//**************************************************************************
function hidetabs(val) {
	var hideit = true;
	if (document.getElementById("wizzrsstab").collapsed) {
		hideit = false;
		document.getElementById("wizzrsstab").collapsed = false;
		document.getElementById("founditems").collapsed = false;
		document.getElementById("saveditems").collapsed = false;
		document.getElementById("wizztabs").setAttribute("tooltiptext", "");
	} else {
		document.getElementById("wizzrsstab").collapsed = true;
		document.getElementById("founditems").collapsed = true;
		document.getElementById("saveditems").collapsed = true;
		document.getElementById("wizztabs").setAttribute("tooltiptext", strbundle.getString("tabstooltip"));
	}
	if (val == 0) {
		writePref("WizzRSSHideTabs", hideit, 2);
	}
}

//**************************************************************************
function hideread() {
	writePref("WizzRSSShowRead", false, 2);
	restoreList();
}

//**************************************************************************
function showread() {
	writePref("WizzRSSShowRead", true, 2);
	restoreList();
}

//**************************************************************************
function addFeedbase() {
	var node = cattree.controller._view.selectedNode;
	getContentBrowser().loadURI("http://www.feedbase.net/Add.php?url=" + escape(node.uri));
}

//**************************************************************************
function validate() {
	var node = cattree.controller._view.selectedNode;
	getContentBrowser().loadURI("http://www.feedvalidator.org/check.cgi?url=" + node.uri);
}

//**************************************************************************
function hidedesc() {
	toggledesc("true");
}

//**************************************************************************
function showdesc() {
	toggledesc("false");
}

//**************************************************************************
function toggledesc(val) {
	document.getElementById("itemsplitter").setAttribute("hidden", val);
	document.getElementById("itemdesc").setAttribute("hidden", val);
	document.getElementById("viewitemsplitter").setAttribute("hidden", val);
	document.getElementById("viewitemdesc").setAttribute("hidden", val);
}

//**************************************************************************
function changeid() {
	var placeuri = getTreePlaceURI()[0];
	cattree.place = placeuri;
}

//**************************************************************************
function shutdown() {
	window.close();
}

//**************************************************************************
function fontChange() {
	cattree.setAttribute("style", "font-size: " + readPref("WizzRSSFontSize", 11, 3) + "px !important;");
	cattree.treeBoxObject.clearStyleAndImageCaches();
	wizzitemlist.setAttribute("style", "font-size: " + readPref("WizzRSSFontSize", 11, 3) + "px !important;");
	viewitemlist.setAttribute("style", "font-size: " + readPref("WizzRSSFontSize", 11, 3) + "px !important;");
	document.getElementById("saveditemlist").setAttribute("style", "font-size: " + readPref("WizzRSSFontSize", 11, 3) + "px !important;");
}

//**************************************************************************
function foundnew(event) {
	if (document.getElementById("wizztabs").selectedIndex == 1) {
		loadViewItems(false, null);
	} else {
		document.getElementById("founditems").setAttribute("style", "font-weight: bold !important;");
	}
}

//**************************************************************************
function savedfile(event) {
	document.getElementById("saveditems").setAttribute("style", "font-weight: bold !important;");
}

//**************************************************************************
function eventHandler(event) {
	updateIndicators();
}

//**************************************************************************
function iconsOff(event) {
	cattree.setAttribute("hideicons", "true");
	cattree.treeBoxObject.clearStyleAndImageCaches();
	cattree.treeBoxObject.invalidate();
}

//**************************************************************************
function iconsOn(event) {
	cattree.setAttribute("hideicons", "false");
	cattree.treeBoxObject.clearStyleAndImageCaches();
	cattree.treeBoxObject.invalidate();
}

//**************************************************************************
function wizzrssunload() {
	writePref("WizzRSSCurrentTab", document.getElementById("wizztabs").selectedIndex, 3);
	try {
		opener.removeEventListener("updateind", eventHandler, true);
		opener.removeEventListener("iconsoff", iconsOff, true);
		opener.removeEventListener("iconson", iconsOn, true);
		opener.removeEventListener("fontchange", fontChange, true);
		opener.removeEventListener("changeid", changeid, true);
		opener.removeEventListener("hidedesc", hidedesc, true);
		opener.removeEventListener("showdesc", showdesc, true);
		opener.removeEventListener("foundnew", foundnew, true);
		opener.removeEventListener("savedfile", savedfile, true);
		if (iswindow) {
			opener.removeEventListener("close", shutdown, true);
		}
	} catch (e) {}
}

//**************************************************************************
function doFBSearch(url) {
	if (!readPref("WizzRSSHideDesc", false, 2)) {
		wizzitemdesc.contentDocument.getElementById("divid").innerHTML = "";
	}
	var data = new Array(url, "Feedbase Search Results", null);
	reader = new itemReader(new Array(data));
	reader.processFeeds();
}

//**************************************************************************
function catTreeSelect(event) {
	var obj = {};
	var row = {};
	cattree.treeBoxObject.getCellAt(event.clientX, event.clientY, row, {}, obj);
	if (row.value == -1) {
		cattree.treeBoxObject.view.selection.currentIndex = -1;
		cattree.treeBoxObject.view.selection.clearSelection();
	} else if (event.button != 2 && !isBusy && obj.value != "twisty" && cattree.currentIndex != -1) {
		var node = cattree.controller._view.selectedNode;
		if (node.type == node.RESULT_TYPE_URI || PlacesUtils.nodeIsLivemarkContainer(node)) {
			processTreeFeed(node);
		} else if (node.type == node.RESULT_TYPE_FOLDER) {
			if (readPref("WizzRSSReadAll", false, 2)) {
				processTreeCat(node);
			}
		}
	}
}

//**************************************************************************
function gohome(event) {
	var obj = {};
	var row = {};
	cattree.treeBoxObject.getCellAt(event.clientX, event.clientY, row, {}, obj);
	if (row.value != -1) {
		var node = cattree.controller._view.selectedNode;
		if (node.type == node.RESULT_TYPE_URI) {
			if (PlacesUtils.annotations.itemHasAnnotation(node.itemId, "bookmarkProperties/feedhome")) {
				var url = PlacesUtils.annotations.getItemAnnotation(node.itemId, "bookmarkProperties/feedhome");
				if (url.length > 0 && url != "none") {				
					getContentBrowser().loadURI(url);
				}
			} else {
				currentResource = node.itemId;
				retrycount = 0;
				setTimeout("tryagain()", 1000);
			}
		}
	}
}

//**************************************************************************
function tryagain() {
	if (PlacesUtils.annotations.itemHasAnnotation(currentResource, "bookmarkProperties/feedhome")) {
		var url = PlacesUtils.annotations.getItemAnnotation(currentResource, "bookmarkProperties/feedhome");
		if (url.length > 0 && url != "none") {
			getContentBrowser().loadURI(url);
		}
	} else {
		if (retrycount < 10) {
			retrycount++;
			setTimeout("tryagain()", 1000);
		}
	}
}

//**************************************************************************
function processTreeFeed(node) {

	if (!readPref("WizzRSSHideDesc", false, 2)) {
		wizzitemdesc.contentDocument.getElementById("divid").innerHTML = "";
	}

	var url;
	if (PlacesUtils.nodeIsLivemarkContainer(node)) {
		var livemarkService = Cc["@mozilla.org/browser/livemark-service;2"].getService(Ci.nsILivemarkService);
		url = livemarkService.getFeedURI(node.itemId).spec;
	} else {
		url = trim(node.uri);
	}
	var feedname = node.title;
	if (url.length > 0) {
		addWizzVisit(node);
		wizzSetFavicon(url);
		var data = new Array(url, feedname, node.itemId);
		var reader = new itemReader(new Array(data));
		reader.processFeeds();
	}
}

//**************************************************************************
function processTreeCat(node) {

	if (!readPref("WizzRSSHideDesc", false, 2)) {
		wizzitemdesc.contentDocument.getElementById("divid").innerHTML = "";
	}

	var folder = node.QueryInterface(Components.interfaces.nsINavHistoryContainerResultNode);
	var currentState = folder.containerOpen;

	if (!currentState) {
		folder.containerOpen = true;
	}

	var transactions = [];
	var urlArray = [];
	for (var i = 0; i < folder.childCount; i ++) {
		var foldernode = folder.getChild(i);
		var isLivemark = PlacesUtils.nodeIsLivemarkContainer(foldernode);
		if (foldernode.type == foldernode.RESULT_TYPE_URI || isLivemark) {
			var url;
			if (isLivemark) {
				var livemarkService = Cc["@mozilla.org/browser/livemark-service;2"].getService(Ci.nsILivemarkService);
				url = livemarkService.getFeedURI(foldernode.itemId).spec;
			} else {
				url = trim(foldernode.uri);
			}

			var feedname = foldernode.title;
			if (url.length > 0) {
				addWizzVisit(foldernode);
				wizzSetFavicon(url);
				var data = new Array(url, feedname, foldernode.itemId);
				urlArray.push(data);
			}
		}
	}

	folder.containerOpen = currentState;

	if (urlArray.length > 0) {
		var aggregate = PlacesUIUtils.ptm.aggregateTransactions("update", transactions);
		PlacesUIUtils.ptm.doTransaction(aggregate);
		var reader = new itemReader(urlArray);
		reader.processFeeds();
	}
}

//**************************************************************************
function catTreeNav(event) {
	var node = cattree.controller._view.selectedNode;
	if(event.keyCode == 38 || event.keyCode == 40) {
		if (!isBusy) {
			if (node.type == node.RESULT_TYPE_URI || PlacesUtils.nodeIsLivemarkContainer(node)) {
				processTreeFeed(node)
			} else if (node.type == node.RESULT_TYPE_FOLDER) {
				if (readPref("WizzRSSReadAll", false, 2)) {
					processTreeCat(node);
				}
			}
		}
	}
}

//**************************************************************************
function catTreeSelectKey(event) {

	var node = cattree.controller._view.selectedNode;
	if(event.keyCode != 38 && event.keyCode != 40) {

		var modkey = false;
		var modid = readPref("WizzRSSModifier", "alt", 1);
		if (modid == "alt" && event.altKey) {
			modkey = true;
		} else if (modid == "control" && event.ctrlKey) {
			modkey = true;
		} else if (modid == "meta" && event.metaKey) {
			modkey = true;
		} else if (modid == "shift" && event.shiftKey) {
			modkey = true;
		}

		if (modkey && (event.charCode == 65 || event.charCode == 97)) { // A

			currentIndex = cattree.currentIndex;
			if (cattree.currentIndex != -1) {
				if (node.type == node.RESULT_TYPE_FOLDER) {
					promptStuff(0);
				}
			} else {
				promptStuff(0);
			}
			event.stopPropagation();
		} else if (modkey && cattree.currentIndex != -1) {
			if (event.charCode == 115 || event.charCode == 83) { // S
				if (cattree.view.selection != null) {
					smtpStuff(0);
					event.stopPropagation();
				}
			} else if (event.charCode == 108 || event.charCode == 76) { // L
				if (cattree.view.selection != null) {
					event.stopPropagation();
					addWatch();
				}
			} else if (event.charCode == 114 || event.charCode == 82) { // R
				if (cattree.view.selection != null) {
					markStuff(1);
					event.stopPropagation();
				}
			} else if (event.charCode == 117 || event.charCode == 85) { // U
				if (cattree.view.selection != null) {
					markStuff(2);
					event.stopPropagation();
				}
			} else if (event.charCode == 100 || event.charCode == 68) { // D
				if (cattree.view.selection != null) {
					deleteStuff();
					event.stopPropagation();
				}
			} else if (event.charCode == 99 || event.charCode == 67) { // C
				if (cattree.view.selection != null) {
					if (node.type == node.RESULT_TYPE_FOLDER) {
						openDialogFrm('addchannel.xul', 2);
						event.stopPropagation();
					}
				}
			} else if (event.charCode == 103 || event.charCode == 71) { // G
				if (cattree.view.selection != null) {
					if (node.type == node.RESULT_TYPE_URI) {
						promptStuff(4);
						event.stopPropagation();
					}
				}
			} else if (event.charCode == 112 || event.charCode == 80) { // P
				if (cattree.view.selection != null) {
					openDialogFrm('properties.xul', 2);
					event.stopPropagation();
				}
			}
		}
	}
}

//**************************************************************************
function busyOn() {
	isBusy = true;
	document.getElementById("busy").setAttribute("src", "chrome://wizzrss/skin/busyred.gif");
}

//**************************************************************************
function busyOff() {
	document.getElementById("busy").setAttribute("src", "");
	isBusy = false;	
}

//**************************************************************************
function displayAlert(msg) {
	//SOUND.beep();
	if (!readPref("WizzRSSHideDesc", false, 2)) {
		var el = wizzitemdesc.contentDocument.getElementById("divid");
		el.innerHTML = "<div align='center'><font color='darkred'>" + msg + "</font></div>";
	}
}

//**************************************************************************
function showMarkPopup(event) {

	event.preventDefault();
	if (wizzitemlist.getRowCount() > 0 && wizzitemlist.selectedIndex != -1) {
		var values = wizzitemlist.selectedItem.value.split("-;-");
		if (values[0] == "Title") {
			//document.getElementById("markitem").setAttribute("disabled", "true");
			//document.getElementById("unmarkitem").setAttribute("disabled", "true");
			document.getElementById("itememail").setAttribute("disabled", "true");
			document.getElementById("newtab").setAttribute("disabled", "true");
		} else {
			//document.getElementById("markitem").setAttribute("disabled", "false");
			//document.getElementById("unmarkitem").setAttribute("disabled", "false");
			document.getElementById("itememail").setAttribute("disabled", "false");
			document.getElementById("newtab").setAttribute("disabled", "false");
			
		}
		document.popupNode = wizzitemlist;
		document.getElementById("markitems").showPopup(wizzitemlist, event.screenX, event.screenY, "popup");
	}
}

//**************************************************************************
function showManagePopup(event) {
	event.preventDefault();

	document.getElementById("addcat").setAttribute("disabled", "true");
	document.getElementById("addchannel").setAttribute("disabled", "true");
	document.getElementById("email").setAttribute("disabled", "true");
	document.getElementById("properties").setAttribute("disabled", "true");
	document.getElementById("mark").setAttribute("disabled", "true");
	document.getElementById("unmark").setAttribute("disabled", "true");
	document.getElementById("search").setAttribute("disabled", "true");
	document.getElementById("wladd").setAttribute("disabled", "true");
	document.getElementById("fbadd").setAttribute("disabled", "true");

	currentIndex = cattree.currentIndex;

	if (cattree.currentIndex != -1) {

		var node = cattree.controller._view.selectedNode;

		var url = "";
		var type = node.type;
		if (type == node.RESULT_TYPE_URI) {
			var url = node.uri;
		}

		if (type == node.RESULT_TYPE_FOLDER) {
			document.getElementById("addcat").setAttribute("disabled", "false");
			document.getElementById("addchannel").setAttribute("disabled", "false");
		}

		if (type == node.RESULT_TYPE_FOLDER || (type == node.RESULT_TYPE_URI && url.length != 0)) {
			document.getElementById("email").setAttribute("disabled", "false");
			document.getElementById("mark").setAttribute("disabled", "false");
			document.getElementById("unmark").setAttribute("disabled", "false");
			document.getElementById("wladd").setAttribute("disabled", "false");
		}

		if (type == node.RESULT_TYPE_FOLDER || type == node.RESULT_TYPE_URI) {
			document.getElementById("properties").setAttribute("disabled", "false");
		}

		if (type == node.RESULT_TYPE_URI) {
			document.getElementById("fbadd").setAttribute("disabled", "false");
		}

		if (url.length != 0) {
			document.getElementById("search").setAttribute("disabled", "false");
		}
	} else {
		document.getElementById("addcat").setAttribute("disabled", "false");
		document.getElementById("addchannel").setAttribute("disabled", "false");
	}
	screenx = event.screenX;
	screeny = event.screenY;
	document.popupNode = cattree;
	document.getElementById("managepopup").showPopup(cattree, event.screenX, event.screenY, "popup");
}

//**************************************************************************
function promptStuff(type) {
	// 0 = Add category
	// 4 = Search Google

	var val;
	var oldval;
	var node = cattree.controller._view.selectedNode;
	if (type == 0) {
		val = prompt(strbundle.getString("addcattext"), "", strbundle.getString("addcattitle"));
		if (val != null && val.length != 0) {
			if (currentIndex == -1) {
				var anno = [];
				var txn = PlacesUIUtils.ptm.createFolder(val, getTreePlaceURI()[2].itemId, -1, anno);
				PlacesUIUtils.ptm.doTransaction(txn);
			} else {
				var anno = [];
				var txn = PlacesUIUtils.ptm.createFolder(val, node.itemId, -1, anno);
				PlacesUIUtils.ptm.doTransaction(txn);
			}
		}
	} else if (type == 4) {
		var domain = node.uri;
		domain = domain.substring(domain.indexOf("/") + 2);
		domain = domain.substring(0, domain.indexOf("/"));
		val = prompt(strbundle.getString("searchtitle") + ": " + domain + "\n" + strbundle.getString("searchstring"), "", strbundle.getString("searchtitle"));
		if (val != null && val.length != 0) {
			val = val.replace(/ /g, "+");
			var url ="http://www.google.com/custom?hl=en&client=pub-4002245024903759&cof=FORID%3A1%3BGL%3A1%3BLBGC%3A336699%3BLC%3A%230000ff%3BVLC%3A%23663399%3BGFNT%3A%230000ff%3BGIMP%3A%230000ff%3BDIV%3A%23336699%3B&domains=" + domain + "&q=" + val + "&btnG=Search&sitesearch=" + domain;
			getContentBrowser().loadURI(url);
		}
	}
}

//**************************************************************************
function confirmStuff(type, node) {
	// 0 = Delete category
	// 2 = Delete feed

	var msg;
	if (type == 0) {
		msg = strbundle.getString("deletecat");
	} else if (type == 2) {
		msg = strbundle.getString("deletechannel");
	} else {
		msg = "Are you sure?";
	}

	if (confirm(msg)) {
		if (node.type == node.RESULT_TYPE_FOLDER) {
			PlacesUtils.bookmarks.removeFolder(node.itemId);
		} else {
			if (PlacesUtils.annotations.itemHasAnnotation(node.itemId, "bookmarkProperties/feedwatched")) {
				if (PlacesUtils.annotations.getItemAnnotation(node.itemId, "bookmarkProperties/feedwatched") == 1) {
					var file = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("ProfD", Ci.nsIFile);
					file.append("wizzrss");
					file.append("wizzrss.sqlite");
					var storageService = Cc["@mozilla.org/storage/service;1"].getService(Ci.mozIStorageService);
					var mDBConn = storageService.openDatabase(file);
					mDBConn.executeSimpleSQL("DELETE FROM wlaggregated WHERE bookmarkid=" + node.itemId);
					mDBConn.close();
				}
			}
			PlacesUtils.bookmarks.removeItem(node.itemId);
		}
	}
}

//**************************************************************************
function deleteStuff() {

	var node = cattree.controller._view.selectedNode;
	var isLivemark = PlacesUtils.nodeIsLivemarkContainer(node);
	if (node.type == node.RESULT_TYPE_FOLDER && !isLivemark) {
		confirmStuff(0, node);
	} else if (node.type == node.RESULT_TYPE_URI || isLivemark) {
		confirmStuff(2, node);
	} else {
		confirmStuff(3, node);
	}
}

//**************************************************************************
function addWatch() {
	var node = cattree.controller._view.selectedNode;
	var isLivemark = PlacesUtils.nodeIsLivemarkContainer(node)
	if (node.type == node.RESULT_TYPE_FOLDER && !isLivemark) {
		var folder = node.QueryInterface(Components.interfaces.nsINavHistoryContainerResultNode);
		var currentState = folder.containerOpen;

		if (!currentState) {
			folder.containerOpen = true;
		}

		for (var i = 0; i < folder.childCount; i ++) {
			var foldernode = folder.getChild(i);
			if (foldernode.type == foldernode.RESULT_TYPE_URI) {
				PlacesUtils.annotations.setItemAnnotation(foldernode.itemId, "bookmarkProperties/feedwatched", true, 1, PlacesUtils.annotations.EXPIRE_NEVER);
				PlacesUtils.annotations.setItemAnnotation(foldernode.itemId, "bookmarkProperties/watchaction", "Find", 3, PlacesUtils.annotations.EXPIRE_NEVER);
			}
		}

		folder.containerOpen = currentState;

	} else if (node.type == node.RESULT_TYPE_URI || isLivemark) {
		PlacesUtils.annotations.setItemAnnotation(node.itemId, "bookmarkProperties/feedwatched", true, 1, PlacesUtils.annotations.EXPIRE_NEVER);
		PlacesUtils.annotations.setItemAnnotation(node.itemId, "bookmarkProperties/watchaction", "Find", 3, PlacesUtils.annotations.EXPIRE_NEVER);
	}	
}

//**************************************************************************
function smtpStuff(val) {
	try {
		if (val == 0) {
			opener.smtpStuff(0, null, cattree);
		} else if (val == 1) {
			var values = wizzitemlist.selectedItem.value.split("-;-");
			if (values.length > 1) {
				var item = wizzitemlist.selectedItem;
				opener.smtpStuff(2, item.label + "-;-" + item.value, null);
			}
		} else {
			opener.smtpStuff(2, itemdesc.contentDocument.getElementById("Title").innerHTML + "-;-" + itemdesc.contentDocument.getElementById("URL").value + "-;-" + itemdesc.contentDocument.getElementById("Text").innerHTML + "-;-", null);
		}
	} catch (e) {}
}

//**************************************************************************
function handleTreeDrop(session, ip) {

	treeDropIP = ip;
	var data = {};
	var length = {};
	var xfer = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);

	if (session.isDataFlavorSupported("text/x-moz-url")) {
		
		xfer.addDataFlavor("text/x-moz-url");
		session.getData(xfer, 0);
		xfer.getTransferData("text/x-moz-url", data, length);
		URL = data.value.QueryInterface(Components.interfaces.nsISupportsString).data.split("\n")[0];

		URL = URL.replace(/&amp;/g, '&');
		busyOn();
		feedcheckdroppedurl = URL;
		opener.addEventListener("feedchecked", checkfeedHandler, true);
		checkFeed(URL);		
	}
}

//**************************************************************************
function checkfeedHandler(event) {
	opener.removeEventListener("feedchecked", checkfeedHandler, true);

	if (checkfeedresult == null) {
		displayAlert(strbundle.getString("dropurlerr"));
	} else {
		var annos = [];
		var anno = {
			name: "bookmarkProperties/feedstatus",
			type: Components.interfaces.nsIAnnotationService.TYPE_STRING,
			flags: 0,
			value: "Unread",
			expires: Components.interfaces.nsIAnnotationService.EXPIRE_NEVER
		};
		annos.push(anno);
		var anno1 = {
			name: DESCRIPTION_ANNO,
			type: Components.interfaces.nsIAnnotationService.TYPE_STRING,
			flags: 0,
			value: checkfeedresult[1],
			expires: Components.interfaces.nsIAnnotationService.EXPIRE_NEVER
		};
		annos.push(anno1);
		var anno2 = {
			name: "bookmarkProperties/feedhome",
			type: Components.interfaces.nsIAnnotationService.TYPE_STRING,
			flags: 0,
			value: checkfeedresult[2],
			expires: Components.interfaces.nsIAnnotationService.EXPIRE_NEVER
		};
		annos.push(anno2);
		var uri = Components.classes['@mozilla.org/network/standard-url;1'].createInstance(Components.interfaces.nsIURI);
		uri.spec = feedcheckdroppedurl;

		var txn = PlacesUIUtils.ptm.createItem(uri, treeDropIP.itemId, treeDropIP.index, trim(checkfeedresult[0]), "", annos);
		PlacesUIUtils.ptm.doTransaction(txn);

	}
	busyOff();
}

//**************************************************************************
var itemListObserver = {

	getSupportedFlavours : function () {
		var flavours = new FlavourSet();
		flavours.appendFlavour("text/x-moz-url");
		return flavours;
	},

	onDragOver : function (evt, flavour, session) {
		if (session.isDataFlavorSupported("moz/x-moz-url")) {
			session.canDrop = true;
		}
	},

	onDrop : function (evt, transData, session) {
		var URL = transData.data.split("\n")[0];
		URL = URL.replace(/&amp;/g, '&');
		var data = new Array(URL, null, null);
		clearList();
		var reader = new itemReader(new Array(data));
		reader.processFeeds();		
	}
}

//**************************************************************************
function clearList() {
	var listcount = wizzitemlist.getRowCount();
	while (listcount != 0) {
		listcount--;
		wizzitemlist.removeItemAt(listcount);
	}
	if (!readPref("WizzRSSHideDesc", false, 2)) {
		wizzitemdesc.contentDocument.getElementById("divid").innerHTML = "";
	}
}

//**************************************************************************
function clearData() {
	var reader = new itemReader(new Array(null));
	reader.deleteLastData();
	clearList();
}

//**************************************************************************
function filterList() {
	var val = prompt(strbundle.getString("filtertext"), readPref("WizzRSSLastFilter", "", 1), strbundle.getString("filtertitle"));
	if (val != null && val.length != 0) {
		val = trim(val);
	}
	if (val != null && val.length != 0) {		
		writePref("WizzRSSLastFilter", val, 1);
		var reader = new itemReader(new Array(null));
		reader.addListItems(val);
	}
}

//**************************************************************************
function restoreList() {
	var reader = new itemReader(new Array(null));
	reader.addListItems(null);
}

//**************************************************************************
function addWizzVisit(node) {
	var historyService = Components.classes["@mozilla.org/browser/nav-history-service;1"].getService(Components.interfaces.nsINavHistoryService);
	var uri = Components.classes['@mozilla.org/network/standard-url;1'].createInstance(Components.interfaces.nsIURI);
	uri.spec = node.uri;
	var time = new Date().valueOf();
	time = time * 1000;
	historyService.addVisit(uri, time, null, 3, false, 0);
}